// leaderboard URL
var gLeaderboardURL = "http://leaderboards.secretexit.com/sdm_leaderboard";


function LevelInfo (leaderboard, name, bundle) {
    this.leaderboard = leaderboard;
    this.name = name;
    this.bundle = bundle;
}


// leaderboard to level name / bundle mapping
// "bundle0" = Free Levels / no bundle
// "bundle1" = Winter Sports
// "bundle2" = Economy Falls
// "bundle3" = Motion
// "bundle4" = Helsinki Hotness
// "bundle5" = Abusement Park
// "bundle6" = Retro
// "bundle7" = Love
// "bundle8" = Big City

var gLevels = [];
gLevels.push(new LevelInfo("84313",     "My First Dismount",        "bundle0"));
gLevels.push(new LevelInfo("85244",     "Classic Stairs",           "bundle0"));
gLevels.push(new LevelInfo("85284",     "Downward Spiral",          "bundle0"));
gLevels.push(new LevelInfo("85294",     "Concrete Results",         "bundle0"));
gLevels.push(new LevelInfo("85304",     "Moonlight Stairflight",    "bundle0"));
gLevels.push(new LevelInfo("85314",     "Stiletto",                 "bundle0"));
gLevels.push(new LevelInfo("85324",     "Mt. Dismount",             "bundle0"));
gLevels.push(new LevelInfo("85334",     "The Ledge",                "bundle0"));
gLevels.push(new LevelInfo("85344",     "Loose Bindings",           "bundle0"));
gLevels.push(new LevelInfo("101284",    "Pyramid Scheme",           "bundle0"));
gLevels.push(new LevelInfo("403813",    "Treehugger",               "bundle0"));
gLevels.push(new LevelInfo("403823",    "Stagefright",              "bundle0"));
gLevels.push(new LevelInfo("485983",    "iFell Tower",              "bundle0"));

gLevels.push(new LevelInfo("519984",    "Skid Marks",               "bundle1"));
gLevels.push(new LevelInfo("520024",    "Brokebutt Mountain",       "bundle1"));
gLevels.push(new LevelInfo("520044",    "Half Pipe, Half Stairs",   "bundle1"));
gLevels.push(new LevelInfo("520054",    "Skier's Resolve",          "bundle1"));
gLevels.push(new LevelInfo("520064",    "Innsbroke Hillside",       "bundle1"));
gLevels.push(new LevelInfo("520074",    "Eagle's Landing",          "bundle1"));

gLevels.push(new LevelInfo("588104",    "Dive Deep",                "bundle2"));
gLevels.push(new LevelInfo("588114",    "Hazard Peak",              "bundle2"));
gLevels.push(new LevelInfo("588124",    "Rapunzel Pachinko",        "bundle2"));
gLevels.push(new LevelInfo("588134",    "Hi There!",                "bundle2"));
gLevels.push(new LevelInfo("588144",    "Birdwatching",             "bundle2"));
gLevels.push(new LevelInfo("588154",    "The Power of Tower",       "bundle2"));

gLevels.push(new LevelInfo("748337",    "Insecurity Measures",      "bundle3"));
gLevels.push(new LevelInfo("748347",    "Descalator",               "bundle3"));
gLevels.push(new LevelInfo("748357",    "Playtime",                 "bundle3"));
gLevels.push(new LevelInfo("748367",    "Elevator Shafted",         "bundle3"));
gLevels.push(new LevelInfo("748377",    "No Pain, No Gain",         "bundle3"));
gLevels.push(new LevelInfo("748387",    "Rat Race",                 "bundle3"));

gLevels.push(new LevelInfo("748397",    "Champion's Demeanor",      "bundle0"));

gLevels.push(new LevelInfo("881327",    "Winter in July",           "bundle4"));
gLevels.push(new LevelInfo("881347",    "Out of Season",            "bundle4"));
gLevels.push(new LevelInfo("881367",    "Slippery When Wet",        "bundle4"));
gLevels.push(new LevelInfo("881387",    "Coming Down Gently",       "bundle4"));
gLevels.push(new LevelInfo("881407",    "Mad World",                "bundle4"));
gLevels.push(new LevelInfo("881417",    "Cruel Summer",             "bundle4"));

gLevels.push(new LevelInfo("890407",    "Sideways",                 "bundle5"));
gLevels.push(new LevelInfo("890417",    "Nordkapp",                 "bundle5"));
gLevels.push(new LevelInfo("890427",    "Unfriendly Chairs",        "bundle5"));
gLevels.push(new LevelInfo("890437",    "Steppers",                 "bundle5"));
gLevels.push(new LevelInfo("890447",    "Bueller Wheel",            "bundle5"));
gLevels.push(new LevelInfo("890467",    "Bumper Jumper",            "bundle5"));

gLevels.push(new LevelInfo("964186",    "Monkey Business",          "bundle6"));
gLevels.push(new LevelInfo("964196",    "Toad Road",                "bundle6"));
gLevels.push(new LevelInfo("964226",    "Plumber's Paradise",       "bundle6"));
gLevels.push(new LevelInfo("964236",    "Space Debris",             "bundle6"));
gLevels.push(new LevelInfo("964276",    "Profit Blocks",            "bundle6"));
gLevels.push(new LevelInfo("964296",    "Yellow Pill",              "bundle6"));

gLevels.push(new LevelInfo("1021307",   "Disassembly Line",         "bundle0"));

gLevels.push(new LevelInfo("1057307",   "Heartbreak Motel",         "bundle7"));
gLevels.push(new LevelInfo("1070227",   "With This Ring",           "bundle7"));
gLevels.push(new LevelInfo("1082257",   "Disfigure Skating",        "bundle7"));
gLevels.push(new LevelInfo("1095387",   "Lovetorrents",             "bundle7"));
gLevels.push(new LevelInfo("1113747",   "Choc Treatment",           "bundle7"));
gLevels.push(new LevelInfo("1123297",   "Hold On Rose",             "bundle7"));

gLevels.push(new LevelInfo("1182907",   "Reach for the Lasers",     "bundle0"));

gLevels.push(new LevelInfo("1208017",   "Mosh Pit",                 "bundle0"));

gLevels.push(new LevelInfo("1208018",   "Holiday Twister",          "bundle0"));

gLevels.push(new LevelInfo("1208019",   "Revolting Doors",          "bundle8"));
gLevels.push(new LevelInfo("1208020",   "Construction Sights",      "bundle8"));
gLevels.push(new LevelInfo("1208021",   "Fred Astairs",             "bundle8"));
gLevels.push(new LevelInfo("1208022",   "Elevator Love",            "bundle8"));
gLevels.push(new LevelInfo("1208023",   "Wax On",                   "bundle8"));
gLevels.push(new LevelInfo("1208024",   "The Big One",              "bundle8"));

gLevels.push(new LevelInfo("1208025",   "New Level",                "bundle0"));
gLevels.push(new LevelInfo("1208026",   "New Level",                "bundle0"));
gLevels.push(new LevelInfo("1208027",   "New Level",                "bundle0"));
gLevels.push(new LevelInfo("1208028",   "New Level",                "bundle0"));
gLevels.push(new LevelInfo("1208029",   "New Level",                "bundle0"));
gLevels.push(new LevelInfo("1208030",   "New Level",                "bundle0"));



function getLevelInfo(leaderboard)
{
    for (var i = 0; i < gLevels.length; i++)
    {
        if (gLevels[i].leaderboard == leaderboard)
            return gLevels[i];
    }

    return new LevelInfo("", "", "");
}



function URLParameters(leaderboard, player, platform, compact)
{
    this.leaderboard = leaderboard;
    this.player = player;
    this.platform = platform;
    this.compact = compact;
}


var gCommonUrlParameters = URLParameters(null, null, null, null);


function getUrlParameter(key)
{
    var result = new RegExp(key + "=([^&]*)", "i").exec(window.location.search);
    if (result == null)
        return null;
    else
        return decodeURIComponent(result[1]);
}


function getCommonUrlParameters()
{
    var leaderboard = getUrlParameter('leaderboard');
    var player = getUrlParameter('player');
    var platform = getUrlParameter('platform');
    var compact = getUrlParameter('compact');
    
    return new URLParameters(leaderboard, player, platform, compact);
}

function getCommonQueryString()
{
    var params = gCommonUrlParameters;
    return "" + (params.leaderboard != null ? "leaderboard=" + params.leaderboard : "") + (params.player != null ? "&player=" + params.player : "") + (params.platform != null ? "&platform=" + params.platform : "") + (params.compact != null ? "&compact=" + params.compact : "");
}


function getCommonQueryStringWOLeaderboard()
{
    var params = gCommonUrlParameters;
    return "" + (params.player != null ? "&player=" + params.player : "") + (params.platform != null ? "&platform=" + params.platform : "") + (params.compact != null ? "&compact=" + params.compact : "");
}


function toggleVisible(id)
{
    var visible = true;
    var container = document.getElementById(id);
    var collapsor = document.getElementById(id + '_collapse')
    if (container == null)
        return;
        
    if(container.style.display == 'none')
        visible = false;

    visible = !visible;

    if (visible)
    {
        container.style.display = 'block';
        collapsor.innerHTML = '&#9660;'
    }
    else
    {
        container.style.display = 'none';
        collapsor.innerHTML = '&#9654;'
    }
}


function hideBundlesExcept(bundle)
{
    var divs = document.getElementsByTagName('div');

    for(var i=0; i<divs.length; i++)
    {
        // see that the div has bundle levels and the bundle wasn't previously viewed
        if(divs[i].className=='bundleContents' && divs[i].id != bundle)
        {
            // collapse / hide div
            divs[i].style.display = 'none';
            var collapsor = document.getElementById(divs[i].id + '_collapse');
            collapsor.innerHTML = '&#9654;'
        }
    }

    // move scroll offset to the anchor with the given bundle id
    var anchorId = bundle + "_anchor";
    var anchor = document.getElementById(anchorId);
    if (anchor)
    {
        document.body.scrollTop = anchor.offsetTop;
    }
}


function hideBundleTitles()
{
    var tds = document.getElementsByTagName('td');

    for(var i=0; i<tds.length; i++)
    {
        if(tds[i].className=='title')
        {
            tds[i].innerHTML = '';
        }
    }
}


function fixLeaderboardLinks()
{
    // appends common parameters to all links with "leaderboard.html"
    var urls = document.getElementsByTagName("a");
    for (var i = 0; i < urls.length; i++)
    {
        var queryString = getCommonQueryStringWOLeaderboard();
        
        if (urls[i].href.indexOf("leaderboard.html") > -1)
        {
            urls[i].href += queryString;
        }
        
    }
}


function getWidth()
{
    // should return clientwidth
    if (self.innerWidth)
       return self.innerWidth;
    else if (document.documentElement && document.documentElement.clientWidth)
        return document.documentElement.clientWidth;
    else if (document.body)
        return document.body.clientWidth;

    return 0;
}


function writeHeaderDivAndListLinkOpen()
{
    gCommonUrlParameters = getCommonUrlParameters();
    var levelInfo = getLevelInfo(gCommonUrlParameters.leaderboard);
    
    var queryString = getCommonQueryString();
    var width = getWidth();
    var style = "";
    if (width > 0)
        style = "style=\"width: " + (getWidth() - 30) + "px;\"";

    document.write("<div id=\"leaderboardHeader\" class=\"leaderboardHeader " + levelInfo.bundle + "\" " + style + ">");
    document.write("<a href=\"list.html?" + queryString + "\">");
}


function writeLeaderboardTryAgainLink()
{
    gCommonUrlParameters = getCommonUrlParameters();
    var queryString = getCommonQueryString();
    document.write("<a style=\"color: #afcfef; text-decoration: underline;\" href=\"leaderboard.html?" + queryString + "\">Try again&nbsp;&nbsp;&#10140;</a>");
}



function writeLevelName()
{
    var levelInfo = getLevelInfo(gCommonUrlParameters.leaderboard);
    document.write("" + levelInfo.name);
}


function writeLeaderboardFrame()
{
    var queryString = getCommonQueryString();
    document.write("<iframe class=\"leaderboard\" src=\"" + gLeaderboardURL + "?" + queryString + "\" frameborder=\"0\" scrolling=\"no\"></iframe>");
}


function initList()
{
    gCommonUrlParameters = getCommonUrlParameters();
    var levelInfo = getLevelInfo(gCommonUrlParameters.leaderboard);

    // hide bundle levels on page load
    hideBundlesExcept(levelInfo.bundle);

    // hide titles if compact mode set
    var compact = gCommonUrlParameters.compact;
    if (compact != null && compact == "1")
        hideBundleTitles();

    // append player id and compact mode to all leaderboard urls
    fixLeaderboardLinks();
}
